<script setup>

import ButtonTag from "@/components/tags/ButtonTag.vue";
import InputTag from "@/components/tags/InputTag.vue";
import {reactive, ref} from "vue";
import {useRegistration} from "@/stores/models/user/registration";
import {useAutharization} from "@/stores/models/user/authorization";
import {useRouter} from "vue-router";


const router = useRouter()
let isLogin = ref(true)
let isLoading = ref(true)

// section AUTHORIZATION
let autharization = reactive({
    email: '',
    password: ''
})

function signIn() {
    isLoading = true
    useAutharization().authUser(autharization)
    .then(() => {
        // Token olingach bosh sahifaga o'tamiz
        router.push('/')
    })
    isLoading = false
}

// section AUTHORIZATION />

// section REGISTRATION

let isValid = ref(false)
let registration = reactive({
    email: '',
    password: '',
    age: 0,
    confirmPassword: ''
})

function signUp() {
    isLoading.value = true
    isValid.value = false

    let data = {
        email: registration.email,
        password: registration.password,
        age: +registration.age
    }

    if (registration.password === registration.confirmPassword) {
        useRegistration().createUser(data)
            .then(() => {
                useAutharization().authUser({email: registration.email, password: registration.password})
                    .then(() => {
                        router.push('/')
                    })
            })
    } else {
        isValid.value = true

    }
    isLoading.value = false
}

// section REGISTRATION />
</script>

<template>
    <div class="row vh-100 justify-content-center align-items-center">
        <div class="col-12 col-sm-8 col-md-6 col-xl-4">
            <div v-if="isLogin" class="h1 text-info text-center pb-3">Login</div>
            <div v-else class="h1 text-info text-center pb-3">Registratsiya</div>
            <div class="row mb-3">
                <div class="col">
                    <ButtonTag @click="isLogin = true" text="Kirish" class="btn-outline-success w-100"/>
                </div>
                <div class="col">
                    <ButtonTag @click="isLogin = false" text="Ro'yxatdan o'tish" class="btn-outline-success w-100"/>
                </div>
            </div>
            <form v-if="isLogin">
                <InputTag v-model="autharization.email" id="signInEmail" label-name="Email" input-type="email"/>
                <InputTag v-model="autharization.password" id="signInPassword" label-name="Parol"
                          input-type="password"/>
                <ButtonTag @click="signIn" text="Kirish" class="btn-primary"/>
            </form>
            <form v-else>
                <InputTag v-model="registration.email" id="signUpEmail" label-name="Email" input-type="email"/>
                <InputTag v-model="registration.age" id="signUpAge" label-name="Yoshingiz" input-type="number"/>
                <InputTag v-model="registration.password" id="signUpPassword" label-name="Parol" input-type="password"/>
                <InputTag v-model="registration.confirmPassword" id="signUpPasswordConfirm"
                          label-name="Parolni tasdiqlang">
                    <small v-if="isValid" class="text-danger">Parolga qara yaramas!!!</small>
                </InputTag>
                <ButtonTag @click="signUp" :loading="isLoading" text="Ro'yxatdan o'tish" class="btn-primary"/>
            </form>
        </div>
    </div>
</template>

<style scoped>

</style>